!include "..\Common.nsh"

;-----------------------------------------------------------------------
; MAIN SCRIPT

SetCompressor /SOLID lzma

!include "MUI.nsh"

Name "RegExpTester"
OutFile "RegExpTester_v1.0.exe"

InstallDir "$PROGRAMFILES\Arnapou\RegExpTester"
InstallDirRegKey HKCU "Software\Arnapou\RegExpTester" ""

!define MUI_ABORTWARNING

#!insertmacro MUI_PAGE_LICENSE "licence.txt"
;!insertmacro MUI_PAGE_COMPONENTS
!insertmacro MUI_PAGE_DIRECTORY
!insertmacro MUI_PAGE_INSTFILES

!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES

!insertmacro MUI_LANGUAGE "English" ;first language is the default language
!insertmacro MUI_LANGUAGE "French"
!insertmacro MUI_LANGUAGE "German"
!insertmacro MUI_LANGUAGE "Spanish"
!insertmacro MUI_LANGUAGE "Italian"
!insertmacro MUI_LANGUAGE "Portuguese"

InstType "Normal"

Section "Programmes" Sec_Program
	SectionIn 1 RO
	SetOutPath $INSTDIR
	File "RegExpTester.exe"
	SetShellVarContext current
	CreateDirectory "$SMPROGRAMS\Arnapou"
	CreateDirectory "$SMPROGRAMS\Arnapou\RegExpTester"
	CreateShortCut "$SMPROGRAMS\Arnapou\RegExpTester\RegExpTester.lnk" "$INSTDIR\RegExpTester.exe"
SectionEnd

Section -PostInstall Sec_PostInstall
	WriteUninstaller "$INSTDIR\uninstall.exe"
	WriteRegStr HKCU "Software\Arnapou\RegExpTester" "" '"$INSTDIR"'
	CreateShortCut "$SMPROGRAMS\Arnapou\RegExpTester\Uninstall.lnk" "$INSTDIR\uninstall.exe"
	SetShellVarContext current
	!insertmacro AddRemovePanel_ADD "Arnapou / RegExpTester" "1.0" "550" "$INSTDIR\uninstall.exe"
SectionEnd 

UninstallText "Voulez-vous dsinstaller Arnapou RegExpTester de votre systme ?"

Section "Uninstall" Sec_Uninstall	
	SetOutPath $TEMP
	DetailPrint "RegExpTester est install  : $INSTDIR"
	RMDir /r /REBOOTOK "$INSTDIR"
	SetShellVarContext current
	RMDir /r "$SMPROGRAMS\Arnapou\RegExpTester"
	
	!insertmacro AddRemovePanel_REMOVE "Arnapou / RegExpTester"
SectionEnd 
