unit regex;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, VBScriptRegex, StdCtrls, ExtCtrls, ComCtrls,
  Common, RegTools;

type
  TForm1 = class(TForm)
    edtPattern: TEdit;
    Panel1: TPanel;
    Label1: TLabel;
    Panel2: TPanel;
    Label2: TLabel;
    Panel3: TPanel;
    Panel4: TPanel;
    btnGO: TButton;
    btnQuitter: TButton;
    Panel5: TPanel;
    lstMatches: TListBox;
    Label3: TLabel;
    edtText: TRichEdit;
    Splitter1: TSplitter;
    Panel6: TPanel;
    Label4: TLabel;
    edtValeur: TRichEdit;
    Splitter2: TSplitter;
    procedure btnGOClick(Sender: TObject);
    procedure btnQuitterClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure lstMatchesClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//---------------------------------------------------------------------------
procedure TForm1.btnGOClick(Sender: TObject);
var
  re: IRegex;
  mc: IMatchCollection;
  iMatch, i: Integer;
  sub: ISubMatches;
begin
  lstMatches.Clear;
  edtValeur.Text := '';
  // Find
  re := VBScriptRegex.Regex.Create(edtPattern.Text);
  mc := re.FindAll(edtText.Text);
  for iMatch := 0 to mc.Count - 1 do begin
    lstMatches.AddItem('['+IntToStr(iMatch)+'] '+mc.Item[iMatch].Value, nil);
    sub := mc.Item[iMatch].SubMatches;
    for i := 0 to sub.Count - 1 do begin
      lstMatches.AddItem('          ['+IntToStr(i)+'] '+sub.Item[i], nil);
    end;
  end;

  if mc.Count = 0 then
    lstMatches.AddItem('-- rien --', nil);
end;
//---------------------------------------------------------------------------
procedure TForm1.btnQuitterClick(Sender: TObject);
begin
  Self.Close;
end;
//---------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
  edtText.Text := 'Lorem ipsum dolor sit amet, consectetuer '+
  'adipiscing elit, sed diam nonummy nibh euismod tincidunt ut '+
  'laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad '+
  'minim veniam, quis nostrud exerci tation ullamcorper suscipit '+
  'lobortis nisl ut aliquip ex ea commodo consequat.';
  RegFormLoadCU(Form1, '\Software\Arnapou\RegExpTester');
end;
//---------------------------------------------------------------------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
  RegFormSaveCU(Form1, '\Software\Arnapou\RegExpTester');
end;
//---------------------------------------------------------------------------
procedure TForm1.FormResize(Sender: TObject);
begin
  edtText.Repaint;
end;
//---------------------------------------------------------------------------
procedure TForm1.lstMatchesClick(Sender: TObject);
var
  k : integer;
  Text : string;
begin
  text := lstMatches.Items[lstMatches.ItemIndex];
  k := instr(text, ']');
  if k > 1 then
    edtValeur.Text := rightstr(text, length(text)-k-1);
end;
//---------------------------------------------------------------------------
end.
